function [k theta VEST]=SAIL(trce,trceTime)
% Infer the parameters of the alternating Gamma renewal process
% Input:
% Steps:
% Output:
% copyright: hung.nguyen@adelaide.edu.au
%%%%%%%%%

n_samples=length(trce);
%Special parameter fo the algorithm
timeInt=1;
%Initial parameter values
ko=[1 1];
thetao=[1 100];

%Infer lambda from trceTime
diff=[];
for i=1:min(2000,length(trceTime))
    diff=[diff (trceTime(i+1)-trceTime(i))];
end
si = mean(diff);
lambda=1/si;

disp(lambda)


maxTime=trceTime(length(trceTime))-trceTime(1);
timeArray = trceTime(1) + [0:timeInt:(maxTime+timeInt)];

binArray=(2)*ones(1,length(trceTime)); %%% 2 is miss, 0 is loss, 1 is good
for t=2:length(trceTime)
    tempk=find((trceTime>=timeArray(t-1))&(trceTime<timeArray(t)));
    if length(tempk)>0
        binArray(t) = trce(tempk(1));
    end
end
O = binArray+1;
PAI=[0.1; 0.9];
A = ones(2,2);
for r=1:2
    A(r,r)=0;
end

D=4000;
P=zeros(2,D);
for i=1:2
    for j=1:D
        P(i,j) =  distF(thetao(i),ko(i),j,lambda);
    end
end
B=[1-exp(-lambda) 0 exp(-lambda);0 1-exp(-lambda) exp(-lambda)]; %%% 3 is unobsrved; 1 is loss, 0 is goodd
IterationNo=50;
%%% Calling the HSMM algorithm
[PAI,A,B,P_est,Qest,lkh] = hsmm_new(PAI,A,B,P,O,IterationNo);


%%%% Process the data to get the parameters
meanEst=[0 0];

meanS=[0 0];
varianceEst=[0 0];
for i=1:2
    for j=1:D
        meanEst(i) =meanEst(i)+j*P_est(i,j);
        meanS(i)=meanS(i)+j^2*P_est(i,j);
    end
    variance(i)= meanS(i) - meanEst(i)*meanEst(i);
end
theta =variance./meanEst;
k=meanEst./theta;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% GETTING THE VARIANCE FOR THE GAMMA DISTRIBUTION
clear temp_laplace_fun
% Prepare the laplace function
F=strcat(num2str(k(1)),'*',num2str(theta(1)),'./((',num2str(k(1)*theta(1) + k(2)*theta(2)),')*s)');
F=strcat(F,'-((',num2str(theta(1)),'*s+1).^',num2str(k(1)),'-1).*((',num2str(theta(2)),'*s+1).^',num2str(k(2)),'-1)');
F=strcat(F,'./','(s.^2*', '(',num2str(k(1)*theta(1) + k(2)*theta(2)),').*','((',num2str(theta(1)),'*s+1).^',num2str(k(1)),'.*(',num2str(theta(2)),'*s+1).^',num2str(k(2)),'-1))');
fid=fopen('temp_laplace_fun.m','w');
fprintf(fid,'function F=temp_laplace_fun(s)');
fprintf(fid,'\n');
fprintf(fid,'	F=');
fprintf(fid,F);
fprintf(fid,';');
fclose(fid);

%Compute the max time lag
tauInt=0.5;
tauArray=ones(n_samples^2,1);
tempID=1;
for i=1:n_samples
    for j =1:n_samples
        tauArray(tempID) =floor(abs(trceTime(i)-trceTime(j))/tauInt)+1;
        tempID=tempID+1;
    end
end
tauMax=max(tauArray);
tau=[10^-10:tauInt:tauMax];

%Perform inverse lapplace transform
RTau=invlap('temp_laplace_fun',tau);

%%%% Check if the result makes sense by looking at the assymptotic
%%%% variance
if ((sum(RTau) < 0)||(2*sum(RTau)/length(RTau)>1))
    disp('Inverse Laplace Transform Failed. Recompute the Autocovariance using simulation');
    tic
    RTau = GETAUTOCOV(k,theta,tau);
    toc
end

%%%% Compute the variance
VEST=0;
for i=1:n_samples
    for j =1:n_samples
        idx=floor(abs(trceTime(i)-trceTime(j))/tauInt)+1;
        if idx<= length(RTau)
            VEST=VEST+RTau(idx);
        end
    end
end
VEST=VEST/n_samples^2;



